struct Quad
{
	bool ul;
	bool ur;
	bool dl;
	bool dr;
};

class Garden;

struct Fitness
{
	int clumpsize;
	int perimeter;
	Garden* g;
	float value;
	int numclumps;
};

class Rule
{
public:
	Rule(void);
	~Rule(void);

	void Copy( Rule* r );
	void InitBasic();
	void Mutate();

	Quad Grow( bool self, bool u, bool r, bool d, bool l );

	Fitness fit;

private:
	bool* grow_in;
	float** grow_wgt;
};
